package hws.hw8;

import java.util.ArrayList;

/**
 * JMU CS themed Pac-Man clone.
 *
 * @author CS159 Faculty and YOUR NAME HERE
 * @version 03/25/2024
 */
public class DuckManGame implements Playable {

    public static final int GRID_SIZE = 32;
    public static final Point PLAYER_SPAWN = new Point(0, 0);
    public static final Point ENEMY_SPAWN = new Point(0, 0);
    
    private boolean running;
    private Level levelMap;

    private ArrayList<Drawable> drawables;

    private NumericDisplay score;
    private NumericDisplay lives;

    /**
     * Default constructor.
     */
    public DuckManGame() {
        levelMap = new Level(GRID_SIZE);
        drawables = new ArrayList<Drawable>();
    }

    /**
     * Draw an image on the screen.
     *
     * @param position where to draw the image
     * @param imagePath path to the image file
     */
    public static void drawImage(Point position, String imagePath) {
        GameDriver.picture(position, GRID_SIZE, imagePath);
    }

    /**
     * Add a dot to the game.
     *
     * @param dot the dot to add
     */
    public void addDot(Dot dot) {
        // TODO
    }

    /**
     * Update the game state when the player collides with dots and enemies.
     */
    public void handlePlayerCollisions() {
        // TODO
    }
    
    /**
     * Iterate through the level map and create a new dot/egg object if the
     * map has a dot/egg at that position.
     */
    public void spawnNewDots() {
        // TODO
    }

    /**
     * Create and add a player to the game.
     */
    public void spawnNewPlayer() {
        // TODO
    }

    /**
     * Create and add enemies to the game.
     */
    public void spawnNewEnemies() {
        // TODO
    }

    @Override
    public void startGame() {
        Point upperLeft = new Point(10, GameDriver.SCREEN_HEIGHT - 10);
        score = new NumericDisplay(upperLeft, "Points", 0);
        drawables.add(score);

        Point upperRight = new Point(GameDriver.SCREEN_WIDTH - 80,
                GameDriver.SCREEN_HEIGHT - 10);
        lives = new NumericDisplay(upperRight, "Lives", 3);
        drawables.add(lives);

        spawnNewDots();
        spawnNewPlayer();
        spawnNewEnemies();

        running = true;
    }

    @Override
    public void updateAll() {
        if (!running) {
            return;
        }
        
        handlePlayerCollisions();
        
        // TODO
    }

    @Override
    public void drawAll() {
        levelMap.draw();
        for (Drawable drawable : drawables) {
            drawable.draw();
        }
    }
}
